<script setup>
    import { ref, reactive, watch } from 'vue';
    import axios from 'axios';
    import ROUTES_API from '@/assets/routesAPI.js'

    const props = defineProps(['ficheDePaie']);

    const personnel = ref([]);

    const employeSelectionne = ref(null);

    const ficheDePaie = reactive({
        date: "",
        idEmploye: "",
        salaireBrut: "",
        cotisationsPatronales: "",
        role: ""
    });

    const validDate = ref(true);
    const validSalaireBrut = ref(true);
    const validCotisationsPatronales = ref(true);
    const validEmploye = ref(true);
    const formIsValid = ref(false);

    const validateForm = () => {
        validDate.value = ficheDePaie.date !== "";
        validSalaireBrut.value = ficheDePaie.salaireBrut !== "";
        validCotisationsPatronales.value = ficheDePaie.cotisationsPatronales !== "";
        validEmploye.value = ficheDePaie.idEmploye !== "";

        formIsValid.value = validDate.value && validSalaireBrut.value && validCotisationsPatronales.value && validEmploye.value;
    };

    watch(() => [ficheDePaie.date, ficheDePaie.salaireBrut, ficheDePaie.cotisationsPatronales, ficheDePaie.idEmploye], () => {
        validateForm();
    });

    axios.get(ROUTES_API.PERSONNEL, {
        headers: {
            'Content-Type': 'application/json',
            'Accept': 'application/json'
        }
    })
    .then(response => {
        if (response.data) {
            personnel.value = response.data;
        }
    })
    .catch(e => {})

    if (props.ficheDePaie) {
        watch(() => props.ficheDePaie.date, () => {
            ficheDePaie.date = props.ficheDePaie.date
            ficheDePaie.idEmploye = props.ficheDePaie.idEmploye
            ficheDePaie.salaireBrut = props.ficheDePaie.salaireBrut
            ficheDePaie.cotisationsPatronales = props.ficheDePaie.cotisationsPatronales
            ficheDePaie.role = props.ficheDePaie.role
            axios.get(ROUTES_API.PERSONNEL + props.ficheDePaie.idEmploye, {
                headers: {
                    'Content-Type': 'application/json',
                    'Accept': 'application/json'
                }
            })
            .then(response => {
                if (response.data) {
                    employeSelectionne.value = response.data;
                }
            })
            .catch(e => {})
        })
    }

    watch(() => employeSelectionne.value != null && employeSelectionne.value.id, () => {
        console.log(employeSelectionne.value.role)
        ficheDePaie.idEmploye = employeSelectionne.value.id
        ficheDePaie.role = employeSelectionne.value.role
    })

</script>

<template>
    <div class="card">
        <div class="card-body">
            <form class="form">
                <div class="form-group">
                    <label for="date">Date</label>
                    <div v-if="!validDate" class="text-danger">La date est requise</div>
                    <input type="date" id="date" class="form-control" v-model="ficheDePaie.date">
                </div>
                <div class="form-group">
                    <label for="employe">Employé</label>
                    <div v-if="!validEmploye" class="text-danger">L'employé est requis</div>
                    <select id="employe" class="form-control" v-model="employeSelectionne">
                        <option v-for="employe in personnel" :value="employe">{{ employe.nom }} {{ employe.prenom }} ({{ employe.role }})</option>
                    </select>
                </div>
                <div class="form-group">
                    <label for="salaireBrut">Salaire Brut</label>
                    <div v-if="!validSalaireBrut" class="text-danger">Le salaire brut est requis</div>
                    <input type="number" id="salaireBrut" class="form-control" v-model="ficheDePaie.salaireBrut">
                </div>
                <div class="form-group">
                    <label for="cotisationsPatronales">Cotisations Patronales</label>
                    <div v-if="!validCotisationsPatronales" class="text-danger">Les cotisations patronales sont requises</div>
                    <input type="number" id="cotisationsPatronales" class="form-control" v-model="ficheDePaie.cotisationsPatronales">
                </div>
                <div class="d-flex justify-content-center">
                    <input type="button" class="btn btn-primary button" @click="$emit('envoie', ficheDePaie)" value="Envoyer" :disabled="!formIsValid">
                </div>
            </form>
        </div>
    </div>
</template>

<style scoped>
    .form-group {
        margin-bottom: 1rem;
    }

    .form {
        justify-content: center;
        align-items: center;
    }
</style>